<template>
    <v-card elevation="4">
        <v-card-title>{{ title }}</v-card-title>
        <v-divider />
        <canvas id="canvas"></canvas>
        <v-divider />
        <v-card-actions>
            <v-btn @click="setChartType('doughnut')">doughnut</v-btn>
            <v-btn @click="setChartType('pie')">pie</v-btn>
        </v-card-actions>
    </v-card>
</template>

<script lang="ts">
// CommitChart.ts
  import Vue from 'vue'
import { Component, Prop, Watch } from 'vue-property-decorator'
import { Chart } from 'chart.js';
import { formatMonth } from "@/utils/date"
import { formatAmount } from "@/utils/price"
// import { ChartData } from 'chart.js';
import { ChartModel } from "@/store/modules/chart"
import { Receipt, Range } from "@/types/calendar"

// interface Categories {
//   food: string
// }
@Component({})
export default class ExpenditureChart extends Vue {
    public total: Number = 0;
    // private width: Number = window.innerWidth;
    // private height: Number = window.innerHeight;
    @Prop({ default: () => [] }) public receipts!: Receipt[]
    @Prop() public range!: Range
    @Prop({ type: ChartModel })
    private state !: ChartModel;
    private chartType: string = "doughnut"

    @Watch("receipts")
    private onReceiptsUpdated() {
        this.loadChart();
    }

    private mounted () {
        this.loadChart();
    }

    private get title() {
        if (this.range === undefined) {
            return "Calendar not loaded"
        } else {
            return formatMonth(this.range.start) + " " + this.$t('chart.receiptsFrom');
        }
    }

    private setChartType(chartType: string) {
        this.chartType = chartType;
        this.loadChart();
    }

    private async loadChart() {
        await this.state.setExpenditureByCategory(this.receipts);

        var canvas = document.getElementById('canvas') as HTMLCanvasElement;
        if (canvas === undefined || canvas === null) return;
        var ctx = canvas.getContext('2d');
        if (ctx) {
            new Chart(ctx, {
                type: this.chartType,
                data: {
                    labels: this.state.labels.map(t =>  this.$t("receipt." + t) as string),
                    datasets: [
                        {
                        label: 'GitHub Commits',
                        backgroundColor: this.state.colors,
                        data: this.state.data
                        }
                    ]
                },
                options: {
                    maintainAspectRatio: true,
                    responsive: true,
                    title: {
                        display: true,
                        text: this.$t("overview.total") + ": " + formatAmount(this.state.total as number),
                        position: "bottom"
                    }
                }
            })
        }

    }
}
</script>
<style scoped>
/* #canvas { 
   width: 400px;
   height: 400px;
   } */
</style>
